################################################################
# Library
################################################################
import time
import argparse
import board
import busio
from adafruit_ht16k33 import segments

################################################################
# Arguments
################################################################

parser = argparse.ArgumentParser(description='7-segment')
parser.add_argument('-d', '--digit', default=0, type=int,
                    help='Digit')

################################################################
# Main
################################################################

def main(args):
    # Create the I2C interface.
    i2c = busio.I2C(board.SCL, board.SDA)

    # Create the LED segment class.
    # This creates a 7 segment 4 character display:
    display = segments.Seg7x4(i2c)

    # Clear the display.
    display.fill(0)

    # Can just print a number
    if args.digit is not None:
        display.print(args.digit)

if __name__ == "__main__":
    args = parser.parse_args()
    main(args)
