**RaspberryPi Digital Sensor Recognition**
=============
## Enviornment
* Raspbian OS 32bit
* Python 3.7.3
* Opencv 4.1.0
* Firebase-admin

## Requirments
Install required build tools
<pre><code>$ sudo apt update
$ sudo apt install libx11-dev
$ sudo apt install libimlib2-dev
</code></pre>
Build ssocr commnad
<pre><code>$ cd build/
$ make clean && make
$ sudo mv ./ssocr /usr/local/bin/ssocr
$ ssocr --version
</code></pre>
Install python package
<pre><code>$ pip install opencv-python
$ pip install opencv-contrib-python
$ pip install firebase-admin
</code></pre>

## Firebase
The results of the digital sensor are sent to Firebase once every 5 seconds.<br>
Data is stored according to the directory structure of Firebase

<code>
Firebase<br/>
├── Analog<br/>
│&nbsp;&nbsp;&nbsp;├── 1: &lt;data1&gt;<br/>
│&nbsp;&nbsp;&nbsp;└── 2: &lt;data2&gt;<br/>
└── Digital<br/>
&nbsp;&nbsp;&nbsp;&nbsp;├── Box0<br/>
&nbsp;&nbsp;&nbsp;&nbsp;│&nbsp;&nbsp;&nbsp;├── 1: &lt;data1&gt;<br/>
&nbsp;&nbsp;&nbsp;&nbsp;│&nbsp;&nbsp;&nbsp;├── 2: &lt;data2&gt;<br/>
&nbsp;&nbsp;&nbsp;&nbsp;│&nbsp;&nbsp;&nbsp;└── 3: &lt;data3&gt;<br/>
&nbsp;&nbsp;&nbsp;&nbsp;└── Box1<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└── 1: &lt;data1&gt;<br/>
</code>

## Digital Sensor Recognition
<pre><code>$ bash example/digital_sensor.sh
</code></pre>
