################################################################
# Library
################################################################
import socket
import subprocess

################################################################
# Global
################################################################
process = None

################################################################
# Main
################################################################

def main():
    # Setting TCP socket
    sock = init_socket()
    sock.listen(1)

    while True:
        # Wait for a connection
        print ('[Info ] Waiting for a connection')
        connection, client_addr = sock.accept()
        try:
            print ('[Info ] Connection from {}:{}'.format(client_addr[0], client_addr[1]))
            # Receive Data
            data = tcp(client=connection)
            print("[Info ] data : {}".format(data))
        finally:
            # Clean up the connection
            print ('[Info ] Clean the connection')
            connection.close()

################################################################
# Function
################################################################

def get_ipaddr():
    # Set socket
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    # Get ip address by sending socket
    try:       
        sock.connect(('10.255.255.255', 1))
        ipaddr = sock.getsockname()[0]
    except Exception:
        ipaddr = '127.0.0.1'
    finally:
        sock.close()
    return ipaddr

def init_socket():
    # Setting socket information
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    local_hostname = socket.gethostname()
    local_fqdn = socket.getfqdn()
    ip_address =  get_ipaddr()

    # Print hostname, domain name and IP address
    print("[Info ] Working on %s (%s) with %s" % (local_hostname, local_fqdn, ip_address))

    # Bind the socket to the port 34567
    pi_address = (ip_address, 34567)  
    sock.bind(pi_address)    
    print('[Info ] Starting up on %s port %s' % pi_address)  
    return sock

def tcp(client):
    data = None
    while data is None:
        data = client.recv(64)
    return data.decode()

if __name__ == "__main__":
    main()
